/*
John William Lynch
CSC 472 : Assignment 4
Know Your Government Final Assignment:
AsyncOfficialDataDownloader:

This parses the data and passes it into the created Official java class
Whichever number the user enters into their location, we will take just the ZIPCODE and go from there,
as the API requires just the zipcode:
 */

package com.example.a472_a4;

import android.annotation.SuppressLint;
import android.net.Uri;
import android.os.AsyncTask;
import android.util.Log;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

import static android.content.ContentValues.TAG;

//////////////////////////////ALL MAIN ACTIVITY CREATION AND OBJECTS DECLARATIONS//////////////////
public class AsyncOfficialDataDownloader extends AsyncTask<String, Integer, String> {

    private MainActivity mainActivity;
    private static String MAIN_URL = "https://www.googleapis.com/civicinfo/v2/representatives?key=";
    private static String API_KEY = "AIzaSyCvKRmdXyWKSBb1KaBtoHFSqz6_vMv8CZQ&";
    private String userEnteredInfo;
    private Object String;
    private static String FINAL_URL = MAIN_URL + API_KEY + "address=";
    //Placeholders for json
    String city, state, zipcode;

    //Constructor for this class:
    public AsyncOfficialDataDownloader(MainActivity ma) {
        mainActivity = ma;
    }

    ///////////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////ON POST EXECUTE DECLARATIONS:////////////////////////////////////
    @SuppressLint("LongLogTag")
    public void onPostExecute(String s) {
        //Empty list:
        if (s == null) {
            return;
        }
        if (s.isEmpty()) {
            Log.d(TAG, "onPostExecute:" + s);
            Toast.makeText(mainActivity,"No data is available for the specified location", Toast.LENGTH_SHORT).show();
        }
        //Else we continue as our String is acceptable and we parse our list:

        if (s.length() > 1 || !(s.isEmpty())) {
            //Pass to parse json
            Log.d(TAG, "onPostExecute:" + s);
            //Create the new official list:
            parseJSON(s);
            mainActivity.setRecyclerOfficialList(parseJSON(s));
            return;
        }
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////DO IN BACKGROUND FOR ASYNC TASK://///////////////////////////////

    //Function taken from given code on D2L That will parse the URL given to use to return the
    //name and symbol of the requested stock. Will have to pass to other async task later in
    //order to retrieve the rest of the data:
    @SuppressLint("LongLogTag")
    protected String doInBackground(String... params) {
        //Access the user passed string using the do in background :
        userEnteredInfo = params[0];
        Log.d(TAG, "inDoInBackground" + userEnteredInfo);
        String finalDataURL = FINAL_URL + userEnteredInfo;
        Uri dataUri = Uri.parse(finalDataURL);
        String urlToUse = dataUri.toString();
        StringBuilder sb = new StringBuilder();
        try {
            URL url = new URL(urlToUse);

            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");

            InputStream is = conn.getInputStream();
            BufferedReader reader = new BufferedReader((new InputStreamReader(is)));
            //Log.d(TAG, "doInBackground: " + sb);
            String line;
            while ((line = reader.readLine()) != null) {
                sb.append(line).append('\n');
            }

            Log.d(TAG, "doInBackground: " + sb.toString());

        } catch (Exception e) {
            Log.e(TAG, "doInBackground: ", e);
            return null;
        }

        return sb.toString();
    }

///////////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////PARSE JSON FOR ASYNC TASK:///////////////////////////////////////
    //Function that will parse our item and add it into a list of stocks:
    //I was originally using this as another item of stocks list, however I found errors in main
    //due to it. Therefore, for the names, it is just an array list of strings, for the full info
    //it is an array list of stocks
    //Added code to ignore a stock if there is no companyName inside of it
    @SuppressLint("LongLogTag")
    private ArrayList<Official> parseJSON(String s) {

        ArrayList<Official> officialList = new ArrayList<>();

        try {
            JSONObject jObjMain = new JSONObject(s);
            //Get normalized input
            JSONObject jNormalizedInput = jObjMain.getJSONObject("normalizedInput");
            //Get offices
            JSONArray jOffices = jObjMain.getJSONArray("offices");
            //Get officials
            JSONArray jOfficials = jObjMain.getJSONArray("officials");
            //Reiterate cities, state, and zip:
            city = jNormalizedInput.getString("city");
            state = jNormalizedInput.getString("state");
            zipcode = jNormalizedInput.getString("zip");
            String fullLocation = city + ", " + state + " " + zipcode;
            //Parse all offices inside the array:
            for (int i = 0; i <jOffices.length(); i++ ){
                JSONObject jObj = jOffices.getJSONObject(i);
                String nameOfOffice = jObj.getString("name");
                String officialIndex = jObj.getString("officialIndices");

                String temporaryIndexItems = officialIndex.substring(1, officialIndex.length()-1);
                String [] temp2 = temporaryIndexItems.split(",");
                int [] indices = new int [temp2.length];
                for (int a = 0; a < temp2.length; a++){
                    indices[a] = Integer.parseInt (temp2[a]);
                }
                Log.d(TAG, "after the second offices for loop" + indices[0]);
                //Integer array we can use to extract information to place into our official array list:
                for (int lastIndex = 0; lastIndex < indices.length; lastIndex++){
                    JSONObject innerJsonObject = jOfficials.getJSONObject(indices[lastIndex]);
                    String address = "";
                    String address2 = "";
                    Log.d(TAG, "in the second offices for loop using jOfficials " + innerJsonObject);
                    String officialName = innerJsonObject.getString("name");
                    if (!(innerJsonObject.has("address")))
                    {
                        address = "No data found";
                        address2 = "No data found";
                    }
                    else {
                        JSONArray fullAddressArray = innerJsonObject.getJSONArray("address");
                        Log.d(TAG, "fullAddressArrayTEST" + fullAddressArray.length());
                        //Check to see how many addresses exist in order to add them all into the
                        //address:
                        if (fullAddressArray.length() < 2) {
                            JSONObject innerFullAddressObject = fullAddressArray.getJSONObject(0);
                            if (innerFullAddressObject.has("line1")) {
                                address += innerFullAddressObject.getString("line1")+ "\n";
                            }
                            if (innerFullAddressObject.has("line2")) {
                                address += innerFullAddressObject.getString("line2")+ "\n";
                            }
                            if (innerFullAddressObject.has("line3")) {
                                address += innerFullAddressObject.getString("line3") + "\n";
                            }
                        }
                        //Else there is only one address:
                        else if (fullAddressArray.length() > 1 ){
                            JSONObject innerFullAddressObject = fullAddressArray.getJSONObject(0);
                            if (innerFullAddressObject.has("line1")) {
                                address += innerFullAddressObject.getString("line1")+ "\n";
                            }
                            if (innerFullAddressObject.has("line2")) {
                                address += innerFullAddressObject.getString("line2")+ "\n";
                            }
                            if (innerFullAddressObject.has("line3")) {
                                address += innerFullAddressObject.getString("line3") + "\n";
                            }
                            //Grab second inner address
                            innerFullAddressObject = fullAddressArray.getJSONObject(1);
                            if (innerFullAddressObject.has("line1")) {
                                address2  += innerFullAddressObject.getString("line1")+ "\n";
                            }
                            if (innerFullAddressObject.has("line2")) {
                                address2 += innerFullAddressObject.getString("line2")+ "\n";
                            }
                            if (innerFullAddressObject.has("line3")) {
                                address2 += innerFullAddressObject.getString("line3") + "\n";
                            }
                            if (innerFullAddressObject.has("city")) {
                                address2 += innerFullAddressObject.getString("city") + " ";
                            }
                            if (innerFullAddressObject.has("state")) {
                                address2 += innerFullAddressObject.getString("state") + ", ";
                            }
                            if (innerFullAddressObject.has("zip")) {
                                address2 += innerFullAddressObject.getString("zip");
                            }
                        }
                    }
                    //Check for existing data: if it is there, add it into that string,
                    //if not set the string to NO DATA
                    String officialParty = "UNKNOWN";
                    if (innerJsonObject.has("party")) {
                        officialParty = innerJsonObject.getString("party");
                        if (officialParty.equals("Democratic Party") || officialParty.equals("Democratic")) {
                            officialParty = "Democratic Party";
                        }
                        else if (officialParty.equals("Republican") || officialParty.equals("Republican Party")) {
                            officialParty = "Republican Party";
                        }
                        else
                        {
                            officialParty = "UNKNOWN";
                        }
                    }
                    String phoneNumber = "NO DATA";
                    if (innerJsonObject.has("phones")){
                        phoneNumber = innerJsonObject.getJSONArray("phones").getString(0);
                    }
                    String url = "NO DATA";
                    if (innerJsonObject.has("urls")){
                        JSONArray urls = innerJsonObject.getJSONArray("urls");
                        url = urls.getString(0);
                    }
                    String email = "NO DATA";
                    if (innerJsonObject.has("emails")){
                        JSONArray emails = innerJsonObject.getJSONArray("emails");
                        email = emails.getString(0);
                    }
                    String photolink = "NO DATA";
                    if (innerJsonObject.has("photoUrl")){
                        photolink = innerJsonObject.getString("photoUrl");
                    }
                    Log.d(TAG, "after parsing the remaining data" + photolink);

                    //Now do a more in depth search to check if there are channels linked to the
                    //specific user:
                    String facebook = "NO DATA";
                    String googlePlus = "NO DATA";
                    String twitter = "NO DATA";
                    String youtube = "NO DATA";
                    //Do a case switch scenario to check for each valid case of the above
                    //post. This way, we can just add if they do exist and don't need to account for
                    //multiple null cases:
                    JSONArray allChannels;
                    if (innerJsonObject.has("channels")){
                        allChannels = innerJsonObject.getJSONArray("channels");
                        if (allChannels != null ){
                            for (int x = 0; x < allChannels.length(); x++){
                                //Type tells us the type of social media it is :ie youtube/twitter etc.
                                String currentChannel = allChannels.getJSONObject(x).getString("type");
                                switch (currentChannel) {
                                    case "YouTube":
                                        youtube = allChannels.getJSONObject(x).getString("id");
                                        break;
                                    case "Facebook":
                                        facebook = allChannels.getJSONObject(x).getString("id");
                                        break;
                                    case "GooglePlus":
                                        googlePlus = allChannels.getJSONObject(x).getString("id");
                                        break;
                                    case "Twitter":
                                        twitter = allChannels.getJSONObject(x).getString("id");
                                        break;
                                    default:
                                        break;
                                }
                            }
                        }
                    }
                    //Create our new official:

                    Official newOffical = new Official(nameOfOffice, officialName, officialParty, phoneNumber, address,
                            address2, email, url, photolink, facebook, googlePlus, twitter, youtube);
                    Log.d(TAG, "Ending of JSON TITLE: " + newOffical.getOfficialTitle());
                    Log.d(TAG, "Ending of JSON NAME: " + newOffical.getOfficialName());
                    Log.d(TAG, "Ending of JSON PARTY: " + newOffical.getOfficialParty());
                    Log.d(TAG, "Ending of JSON PNUM: " + newOffical.getOfficialPhoneNumber());
                    Log.d(TAG, "Ending of JSON Office1: " + newOffical.getOfficialOfficeAddress());
                    Log.d(TAG, "Ending of JSON Office2: " + newOffical.getOfficialSubOfficeAddress());
                    Log.d(TAG, "Ending of JSON Email: " + newOffical.getOfficialSubOfficeAddress());
                    Log.d(TAG, "Ending of JSON WEBSITE: " + newOffical.getOfficialWebsite());
                    Log.d(TAG, "Ending of JSON PHOTO-URL: " + newOffical.getPhotoURL());
                    Log.d(TAG, "Ending of JSON FB: " + newOffical.getFacebookURL());
                    Log.d(TAG, "Ending of JSON G: " + newOffical.getGooglePlusURL());
                    Log.d(TAG, "Ending of JSON TWITTER: " + newOffical.getTwitterURL());
                    Log.d(TAG, "Ending of JSON YTUBE: " + newOffical.getYoutubeURL());

                    officialList.add(newOffical);
                }
            }

          //Now return the newly created list:
            return officialList;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

///////////////////////////////////////////////////////////////////////////////////////////////
}