/*
John William Lynch
CSC 472 : Assignment 4
Know Your Government Final Assignment:
Official Class:
Holds all data to display information regarding an official

 */

package com.example.a472_a4;

//There are only a select amount of items displayed in certain scenarios, for instance in the recycler
//view of the officials we only see the Official Job Title, their name, and party:

import java.io.Serializable;

public class Official implements Serializable {

    //For Scrollable Recycler View:
    private String officialTitle;
    private String officialName;
    private String officialParty;

    //For Information Page:
    private String officialPhoneNumber;
    private String officialOfficeAddress;
    private String officialSubOfficeAddress;
    private String officialWebsite;
    private String photoURL;
    private String email;

    //Social Media URL Links:
    private String facebookURL;
    private String googlePlusURL;
    private String twitterURL;
    private String youtubeURL;

    //Placeholders for edge cases where no data is found or party is unknown:
    private static final String EMPTY_DATA = "No data could be retrieved";
    private static final String UNKNOWN_PARTY = "UNKNOWN";


    //Constructor for testing:
    public Official(String name, String office, String party){
        this.officialName = name;
        this.officialTitle = office;
        this.officialParty = party;
    }

    //Empty constructor that sets all variables;
    public Official() {
        //Recycler view items:
        this.officialTitle = EMPTY_DATA;
        this.officialName = EMPTY_DATA;
        this.officialParty = EMPTY_DATA;
        //For Information Page:
        this.officialPhoneNumber = EMPTY_DATA;
        this.officialOfficeAddress = EMPTY_DATA;
        this.officialSubOfficeAddress = EMPTY_DATA;
        this.officialWebsite = EMPTY_DATA;
        this.photoURL = EMPTY_DATA;
        //For Social Media:
        this.facebookURL = EMPTY_DATA;
        this.googlePlusURL = EMPTY_DATA;
        this.twitterURL = EMPTY_DATA;
        this.youtubeURL = EMPTY_DATA;
    }

    //Constructor to use once we parse data and find all the information we need:
    //Empty constructor that sets all variables;
    public Official(String title, String name, String party,
                    String pNum, String oAddress, String oSAddress, String email,
                    String website, String photoURL, String fbURL,
                    String gURL, String twitterURL, String youtubeURL) {
        //Recycler view items:
        this.officialTitle = title;
        this.officialName = name;
        this.officialParty = party;
        //For Information Page:
        this.officialPhoneNumber = pNum;
        this.officialOfficeAddress = oAddress;
        this.officialSubOfficeAddress = oSAddress;
        this.email = email;
        this.officialWebsite = website;
        this.photoURL = photoURL;
        //For Social Media:
        this.facebookURL = fbURL;
        this.googlePlusURL = gURL;
        this.twitterURL = twitterURL;
        this.youtubeURL = youtubeURL;
    }
//////////////////////////////////GET & SET METHODS OF ALL FUNCTIONS////////////////////////////////


    public String getOfficialTitle() {
        return officialTitle;
    }

    public void setOfficialTitle(String officialTitle) {
        this.officialTitle = officialTitle;
    }

    public String getOfficialName() {
        return officialName;
    }

    public void setOfficialName(String officialName) {
        this.officialName = officialName;
    }

    public String getOfficialParty() {
        return officialParty;
    }

    public void setOfficialParty(String officialParty) {
        this.officialParty = officialParty;
    }

    public String getOfficialPhoneNumber() {
        return officialPhoneNumber;
    }

    public void setOfficialPhoneNumber(String officialPhoneNumber) {
        this.officialPhoneNumber = officialPhoneNumber;
    }

    public String getOfficialOfficeAddress() {
        return officialOfficeAddress;
    }

    public void setOfficialOfficeAddress(String officialOfficeAddress) {
        this.officialOfficeAddress = officialOfficeAddress;
    }

    public String getOfficialSubOfficeAddress() {
        return officialSubOfficeAddress;
    }

    public void setOfficialSubOfficeAddress(String officialSubOfficeAddress) {
        this.officialSubOfficeAddress = officialSubOfficeAddress;
    }

    public String getOfficialWebsite() {
        return officialWebsite;
    }

    public void setOfficialWebsite(String officialWebsite) {
        this.officialWebsite = officialWebsite;
    }

    public String getPhotoURL() {
        return photoURL;
    }

    public void setPhotoURL(String photoURL) {
        this.photoURL = photoURL;
    }

    public String getFacebookURL() {
        return facebookURL;
    }

    public void setFacebookURL(String facebookURL) {
        this.facebookURL = facebookURL;
    }

    public String getGooglePlusURL() {
        return googlePlusURL;
    }

    public void setGooglePlusURL(String googlePlusURL) {
        this.googlePlusURL = googlePlusURL;
    }

    public String getTwitterURL() {
        return twitterURL;
    }

    public void setTwitterURL(String twitterURL) {
        this.twitterURL = twitterURL;
    }

    public String getYoutubeURL() {
        return youtubeURL;
    }

    public void setYoutubeURL(String youtubeURL) {
        this.youtubeURL = youtubeURL;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }
    ///////////////////////////////////////////////////////////////////////////////////////

    /////////////////////////////////TO STRING METHOD:///////////////////////////////////////

    @Override
    public String toString() {
        return "Official{" +
                "officialTitle='" + officialTitle + '\'' +
                ", officialName='" + officialName + '\'' +
                ", officialParty='" + officialParty + '\'' +
                ", officialPhoneNumber='" + officialPhoneNumber + '\'' +
                ", officialOfficeAddress='" + officialOfficeAddress + '\'' +
                ", officialSubOfficeAddress='" + officialSubOfficeAddress + '\'' +
                ", officialWebsite='" + officialWebsite + '\'' +
                ", photoURL='" + photoURL + '\'' +
                ", facebookURL='" + facebookURL + '\'' +
                ", googlePlusURL='" + googlePlusURL + '\'' +
                ", twitterURL='" + twitterURL + '\'' +
                ", youtubeURL='" + youtubeURL + '\'' +
                '}';
    }
}
