/*
John William Lynch
CSC 472 : Assignment 4
Know Your Government Final Assignment:
Official Activity :

 */

package com.example.a472_a4;

import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;
import android.os.Bundle;

import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

public class OfficialActivity extends AppCompatActivity  {

    ////////////////////////////////ALL VAR DECLARATIONS AND ON CREATE//////////////////////////////
    //Access all Text Views and declare them for later use:
    TextView officialTitle, officialName, officialParty, officialAddress, officialPhone, officialEmail, officialWebsite;
    ImageView officialDisplay, officialPartyLogo, facebookImage, twitterImage, googleImage, youtubeImage;
    TextView addressLabel, phoneLabel, emailLabel, websiteLabel;

    Official currentOfficial;
    private static final String TAG = "onCreate";

    @Override
    protected  void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_official);

        //Set the Title of the Project:
        setTitle("Know Your Government");
        //Set the color of the action and menu bar:
        ActionBar menuBar = getSupportActionBar();
        menuBar.setBackgroundDrawable(new ColorDrawable(ContextCompat.getColor(this.getApplicationContext(), R.color.menuBackground)));

        Window statusBar = this.getWindow();
        statusBar.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
        statusBar.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
        statusBar.setStatusBarColor(ContextCompat.getColor(this, R.color.topStatusBarColor));

        //Grab current location from previous activity:
        TextView loc = findViewById(R.id.locationPlaceholder);
        String currentLocFromAct;
        currentLocFromAct = getIntent().getSerializableExtra("CurrentLocation").toString();
        loc.setText(currentLocFromAct);
        Toast.makeText(this, currentLocFromAct, Toast.LENGTH_SHORT).show();

        //Grab the official that was selected:
        currentOfficial = (Official) getIntent().getSerializableExtra("MainActivity");

        //Set all items to their respective targets:
        officialTitle = findViewById(R.id.officialTitleDisplay);
        officialName = findViewById(R.id.officialNameDisplay);
        officialParty = findViewById(R.id.officialPartyAffiliation);
        officialDisplay = findViewById(R.id.officialProfilePicture);
        officialPartyLogo = findViewById(R.id.officialPartyLogo);

        //officialDisplay = findViewById(R.id.officialProfilePicture);
        //Only display it using picasso if link exists, otherwise display a placeholder image:
        if (checkNetworkStatus() == true){
            officialDisplay.setImageResource(R.drawable.placeholder);
            if (currentOfficial.getPhotoURL().equals("NO DATA")){
                loadPlaceholderImage();
            }
            else {
                loadRemoteImage(currentOfficial.getPhotoURL());
            }
        }
        else if (checkNetworkStatus() == false){
            officialDisplay.setImageResource(R.drawable.brokenimage);
        }
        Log.d(TAG,"onCreate:" + currentOfficial.getPhotoURL());

        //Set items now for each item we have found:
        officialTitle.setText(currentOfficial.getOfficialTitle());
        officialName.setText(currentOfficial.getOfficialName());
        officialParty.setText("(" + currentOfficial.getOfficialParty() + ")");
        if (officialParty.getText().toString().equals("(Democratic Party)")) {
            officialPartyLogo.setImageResource(R.drawable.dem_logo);
            getWindow().getDecorView().setBackgroundColor(Color.BLUE);
        }
        else if (officialParty.getText().toString().equals("(Republican Party)")){
            officialPartyLogo.setImageResource(R.drawable.rep_logo);
            getWindow().getDecorView().setBackgroundColor(Color.RED);
        }
        else if (officialParty.getText().toString().equals("(UNKNOWN)")) {
            officialPartyLogo.setVisibility(View.GONE);
            getWindow().getDecorView().setBackgroundColor(Color.BLACK);
        }

        //Now we need to parse data to check if it exists or not:
        //Set all items to their respective targets:
        officialAddress = findViewById(R.id.addressInfo);
        officialPhone = findViewById(R.id.phoneInfo);
        officialEmail = findViewById(R.id.emailInfo);
        officialWebsite = findViewById(R.id.websiteInfo);

        //Grab labels to check if we need to show / hide them as well:
        addressLabel = findViewById(R.id.addressLabel);
        phoneLabel = findViewById(R.id.phoneLabel);
        emailLabel = findViewById(R.id.emailLabel);
        websiteLabel = findViewById(R.id.websiteLabel);

        //Get SOCIAL MEDIA Icons:
        facebookImage = findViewById(R.id.facebookButton);
        twitterImage = findViewById(R.id.twitterButton);
        googleImage = findViewById(R.id.googleplusButton);
        youtubeImage = findViewById(R.id.youtubeButton);

        //Check if any items are empty: hide if they are:
        if (currentOfficial.getOfficialOfficeAddress() != null){
            if (currentOfficial.getOfficialOfficeAddress().equals("No data found")){
                officialAddress.setVisibility(View.GONE);
                addressLabel.setVisibility(View.GONE);
            }
            else {
                officialAddress.setText(currentOfficial.getOfficialOfficeAddress());
            }
        }

        if (currentOfficial.getOfficialPhoneNumber() != null){
            if (currentOfficial.getOfficialPhoneNumber().equals("NO DATA")){
                officialPhone.setVisibility(View.GONE);
                addressLabel.setVisibility(View.GONE);
            }
            else {
                officialPhone.setText(currentOfficial.getOfficialPhoneNumber());
                phoneLabel.setVisibility(View.VISIBLE);
            }
        }
        if (currentOfficial.getEmail() != null) {
            if(currentOfficial.getEmail().equals("NO DATA")){
                officialEmail.setVisibility(View.GONE);
                emailLabel.setVisibility(View.GONE);
            }
            else {
                officialEmail.setText(currentOfficial.getEmail());
                emailLabel.setVisibility(View.VISIBLE);
            }
        }
        if (currentOfficial.getOfficialWebsite() != null) {
            if (currentOfficial.getOfficialWebsite().equals("NO DATA")){
                officialWebsite.setVisibility(View.GONE);
                websiteLabel.setVisibility(View.GONE);
            }
            else{
                officialWebsite.setText(currentOfficial.getOfficialWebsite());
                websiteLabel.setVisibility(View.VISIBLE);
             }
        }

        //Check social medial and determine which links to show:
        if (currentOfficial.getFacebookURL().equals("NO DATA")){
            facebookImage.setVisibility(View.GONE);
        }
        if (currentOfficial.getYoutubeURL().equals("NO DATA")) {
            youtubeImage.setVisibility(View.GONE);
        }
        if (currentOfficial.getTwitterURL().equals("NO DATA")){
            twitterImage.setVisibility(View.GONE);
        }
        if (currentOfficial.getGooglePlusURL().equals("NO DATA")){
            googleImage.setVisibility(View.GONE);
        }




    }
    ////////////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////////ON CLICK METHODS CREATED HERE/////////////////////////////////
    //Clicked on photo method:
    public void getPhotoActivity(View v) {
        //Skip if no user photo present:
        if (currentOfficial.getPhotoURL().equals("NO DATA")) {
            return;
        }
        if (checkNetworkStatus() == false){
            Toast.makeText(this, "Cannot access while not connected", Toast.LENGTH_SHORT).show();
        }
        //Pass over the intent and other items to the new activity
        Intent newIntent = new Intent(OfficialActivity.this, PhotoActivity.class);
        newIntent.putExtra("OfficialActivity", currentOfficial);
        TextView currentLoc = findViewById(R.id.locationPlaceholder);
        newIntent.putExtra("CurrentLocation",(currentLoc.getText()).toString());
        startActivity(newIntent);
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////////NETWORK CONNECTION TEST///////////////////////////////////////
    private boolean checkNetworkStatus() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        if (cm == null) {
            Toast.makeText(this, "Cannot access ConnectivityManager", Toast.LENGTH_SHORT).show();
            return false;
        }

        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        //If it is connected, return true. If not connected, return false:
        if (netInfo != null && netInfo.isConnected()) {
            return true;
        } else {
            return false;
        }
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////

    /////////////////////////////////IMAGE DOWNLOADER CODE//////////////////////////////////////////
    private void loadRemoteImage(final String imageURL) {
        // Needs gradle  implementation 'com.squareup.picasso:picasso:2.71828'

        Picasso picasso = new Picasso.Builder(this).build();
        picasso.load(imageURL)
                .error(R.drawable.brokenimage)
                .placeholder(R.drawable.placeholder)
                .into(officialDisplay);
    }

    //If no photo is offered
    private void loadPlaceholderImage() {
        Picasso picasso = new Picasso.Builder(this).build();
        picasso.load(R.drawable.missing)
                .error(R.drawable.brokenimage)
                .placeholder(R.drawable.placeholder)
                .into(officialDisplay);
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////

    //////////////////////////////////SOCIAL MEDIA ICONS CLICKED////////////////////////////////////
    //provided to us inside of the pdf for assignment:
    //Twitter:
    public void twitterClicked(View v) {
        Intent intent = null;
        currentOfficial.getTwitterURL();
        String name = currentOfficial.getTwitterURL();
        try {
            // get the Twitter app if possible
            getPackageManager().getPackageInfo("com.twitter.android", 0);
            intent = new Intent(Intent.ACTION_VIEW, Uri.parse("twitter://user?screen_name=" + name));
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        } catch (Exception e) {
            // no Twitter app, revert to browser
            intent = new Intent(Intent.ACTION_VIEW, Uri.parse("https://twitter.com/" + name));
        }
        startActivity(intent);
    }
    //Facebook:
    public void facebookClicked(View v) {
        String FACEBOOK_URL = "https://www.facebook.com/" + currentOfficial.getFacebookURL();
        String urlToUse = "";
        PackageManager packageManager = getPackageManager();
        try {
            int versionCode = packageManager.getPackageInfo("com.facebook.katana", 0).versionCode;
            if (versionCode >= 3002850) { //newer versions of fb app
                urlToUse = "fb://facewebmodal/f?href=" + FACEBOOK_URL;
                /*
            } else { //older versions of fb app
                urlToUse = "fb://page/" + channels.get("Facebook");

                 */
            }
        } catch (PackageManager.NameNotFoundException e) {
            urlToUse = FACEBOOK_URL; //normal web url
        }
        Intent facebookIntent = new Intent(Intent.ACTION_VIEW);
        facebookIntent.setData(Uri.parse(urlToUse));
        startActivity(facebookIntent);
    }

    //Google Plus
    public void googlePlusClicked(View v) {
        String name = currentOfficial.getGooglePlusURL();
        Intent intent = null;
        try {
            intent = new Intent(Intent.ACTION_VIEW);
            intent.setClassName("com.google.android.apps.plus",
                    "com.google.android.apps.plus.phone.UrlGatewayActivity");
            intent.putExtra("customAppUri", name);
            startActivity(intent);
        } catch (ActivityNotFoundException e) {
            startActivity(new Intent(Intent.ACTION_VIEW,
                    Uri.parse("https://plus.google.com/" + name)));
        }
    }

    //YouTube:
    public void youTubeClicked(View v) {
        String name = currentOfficial.getYoutubeURL();
        Intent intent = null;
        try {
            intent = new Intent(Intent.ACTION_VIEW);
            intent.setPackage("com.google.android.youtube");
            intent.setData(Uri.parse("https://www.youtube.com/" + name));
            startActivity(intent);
        } catch (ActivityNotFoundException e) {
            startActivity(new Intent(Intent.ACTION_VIEW,
                    Uri.parse("https://www.youtube.com/" + name)));
        }
    }





    ////////////////////////////////////////////////////////////////////////////////////////////////
}
