/*
John William Lynch
CSC 472 : Assignment 4
Know Your Government Final Assignment:
Official Class:
Adapter for parsing all of the officials and showing them properly:

 */
package com.example.a472_a4;

import android.annotation.SuppressLint;
import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.core.content.ContextCompat;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;


public class OfficialAdapter extends RecyclerView.Adapter<OfficialViewHolder>{

    private static final String tag = "StockAdapter";
    private List<Official> officialList;
    private MainActivity mainAct;

    int color;
    char arrowSymbol;

    OfficialAdapter (List<Official> nList, MainActivity mainA){
        this.officialList = nList;
        this.mainAct = mainA;
    }

    @NonNull
    @Override
    public OfficialViewHolder onCreateViewHolder (@NonNull final ViewGroup parent, int viewType){
        View itemView = LayoutInflater.from(parent.getContext()).inflate(R.layout.official_list_row, parent, false);
        itemView.setOnClickListener(mainAct);
        return new OfficialViewHolder(itemView);
    }

    @SuppressLint("ResourceAsColor")
    @Override
    public void onBindViewHolder(@NonNull OfficialViewHolder holder, int position) {
        Official official = officialList.get(position);
        //More info needs to be added : figure out how to add information to each stock item:
        holder.position.setText(official.getOfficialTitle());
        holder.name.setText(official.getOfficialName());
        holder.party.setText("(" + official.getOfficialParty() + ")");
        //Set the colors of all items after filling them in with data:
        holder.position.setTextColor(R.color.officialHolderTitleTextColor);
        holder.name.setTextColor(R.color.officialHolderTextColor);
        holder.party.setTextColor(R.color.officialHolderTextColor);

    }

    @Override
    public int getItemCount() {
        return officialList.size();
    }

}
