/*
John William Lynch
CSC 472 : Assignment 4
Know Your Government Final Assignment:
Photo Activity :
 */

package com.example.a472_a4;

import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.Uri;
import android.os.Bundle;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.TextView;
import android.os.Bundle;

import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;

import androidx.appcompat.app.ActionBar;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

public class PhotoActivity extends AppCompatActivity {
    //Access all Text Views and declare them for later use:
    TextView officialTitle, officialName, officialParty, officialAddress, officialPhone, officialEmail, officialWebsite;
    ImageView officialDisplay, officialPartyLogo, facebookImage, twitterImage, googleImage, youtubeImage;
    TextView addressLabel, phoneLabel, emailLabel, websiteLabel;

    Official currentOfficial;
    private static final String TAG = "onCreate";

    @Override
    protected  void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_photo);

        //Set the Title of the Project:
        setTitle("Know Your Government");
        //Set the color of the action and menu bar:
        ActionBar menuBar = getSupportActionBar();
        menuBar.setBackgroundDrawable(new ColorDrawable(ContextCompat.getColor(this.getApplicationContext(), R.color.menuBackground)));

        Window statusBar = this.getWindow();
        statusBar.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
        statusBar.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
        statusBar.setStatusBarColor(ContextCompat.getColor(this, R.color.topStatusBarColor));

        //Grab current location from previous activity:
        TextView loc = findViewById(R.id.locationPlaceholder);
        String currentLocFromAct;
        currentLocFromAct = getIntent().getSerializableExtra("CurrentLocation").toString();
        loc.setText(currentLocFromAct);
        Toast.makeText(this, currentLocFromAct, Toast.LENGTH_SHORT).show();

        //Grab the official that was selected:
        currentOfficial = (Official) getIntent().getSerializableExtra("OfficialActivity");

        //Set all items to their respective targets:
        officialTitle = findViewById(R.id.officialTitleDisplay);
        officialName = findViewById(R.id.officialNameDisplay);
        officialParty = findViewById(R.id.officialPartyAffiliation);
        officialDisplay = findViewById(R.id.officialProfilePicture);
        officialPartyLogo = findViewById(R.id.officialPartyLogo);

        //officialDisplay = findViewById(R.id.officialProfilePicture);
        //Only display it using picasso if link exists, otherwise display a placeholder image:
        if (checkNetworkStatus() == true){

            officialDisplay.setImageResource(R.drawable.placeholder);
            if (currentOfficial.getPhotoURL().equals("NO DATA")){
                loadPlaceholderImage();
            }
            else {
                loadRemoteImage(currentOfficial.getPhotoURL());
            }
        }
        else if (checkNetworkStatus() == false){
            officialDisplay.setImageResource(R.drawable.brokenimage);
        }

        //Set items now for each item we have found:
        officialTitle.setText(currentOfficial.getOfficialTitle());
        officialName.setText(currentOfficial.getOfficialName());
        officialParty.setText("(" + currentOfficial.getOfficialParty() + ")");
        if (officialParty.getText().toString().equals("(Democratic Party)")) {
            officialPartyLogo.setImageResource(R.drawable.dem_logo);
            getWindow().getDecorView().setBackgroundColor(Color.BLUE);
        }
        else if (officialParty.getText().toString().equals("(Republican Party)")){
            officialPartyLogo.setImageResource(R.drawable.rep_logo);
            getWindow().getDecorView().setBackgroundColor(Color.RED);
        }
        else if (officialParty.getText().toString().equals("(UNKNOWN)")) {
            officialPartyLogo.setVisibility(View.GONE);
            getWindow().getDecorView().setBackgroundColor(Color.BLACK);
        }

    }
    //////////////////////////////////NETWORK CONNECTION TEST///////////////////////////////////////
    private boolean checkNetworkStatus() {
        ConnectivityManager cm = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        if (cm == null) {
            Toast.makeText(this, "Cannot access ConnectivityManager", Toast.LENGTH_SHORT).show();
            return false;
        }

        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        //If it is connected, return true. If not connected, return false:
        if (netInfo != null && netInfo.isConnected()) {
            return true;
        } else {
            return false;
        }
    }

    ////////////////////////////////////////////////////////////////////////////////////////////////

    /////////////////////////////////IMAGE DOWNLOADER CODE//////////////////////////////////////////
    private void loadRemoteImage(final String imageURL) {
        // Needs gradle  implementation 'com.squareup.picasso:picasso:2.71828'

        Picasso picasso = new Picasso.Builder(this).build();
        picasso.load(imageURL)
                .error(R.drawable.brokenimage)
                .placeholder(R.drawable.placeholder)
                .into(officialDisplay);
    }

    //If no photo is offered
    private void loadPlaceholderImage() {
        Picasso picasso = new Picasso.Builder(this).build();
        picasso.load(R.drawable.missing)
                .error(R.drawable.brokenimage)
                .placeholder(R.drawable.placeholder)
                .into(officialDisplay);
    }
    ////////////////////////////////////////////////////////////////////////////////////////////////

    }
